﻿using Syncfusion.UI.Xaml.Diagram;
using Syncfusion.UI.Xaml.Diagram.Controls;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Adding_Port
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            
            diagram.Nodes = new ObservableCollection<NodeViewModel>();
            diagram.Connectors = new ObservableCollection<ConnectorViewModel>();

            NodeViewModel node = AddNode(100, 100, "Node");
            
            //Add Port to the Node in particular position
            AddPort(node, 0.5, 0);
            AddPort(node, 1, 0.5);
            AddPort(node, 0.5, 1);
        }

        public NodeViewModel AddNode(double offx, double offy, string name)
        {
            NodeViewModel node = new NodeViewModel()
            {
                UnitHeight = 100,
                UnitWidth = 100,
                OffsetX = offx,
                OffsetY= offy,
                Annotations = new ObservableCollection<IAnnotation>()
                {
                    new AnnotationEditorViewModel()
                    {
                        Content=name
                    }
                }
            };
            (diagram.Nodes as ObservableCollection<NodeViewModel>).Add(node);
            return node;
        }

        public NodePortViewModel AddPort(NodeViewModel node, double offx, double offy)
        {
            NodePortViewModel nodeport = new NodePortViewModel()
            {
                UnitHeight = 10,
                UnitWidth = 10,
                NodeOffsetX = offx,
                NodeOffsetY = offy
            };
            nodeport.PortVisibility = PortVisibility.Visible;
            nodeport.Constraints &= ~PortConstraints.InheritPortVisibility;
            if(node.Ports == null)
            {
                node.Ports = new ObservableCollection<NodePortViewModel>();
            }
            (node.Ports as ObservableCollection<NodePortViewModel>).Add(nodeport);
            return nodeport;
        }
    }
}
